diff -r 411de35de7fc -r 78219b10be7c libinterp/corefcn/stack-frame.cc
--- a/libinterp/corefcn/stack-frame.cc	Mon Jan 22 11:27:42 2024 +0100
+++ b/libinterp/corefcn/stack-frame.cc	Mon Jan 22 23:38:08 2024 +0100
@@ -765,8 +656,193 @@
           lazy_data ().m_arg_names = val;
           return;
         default:
-          panic ("bytecode_fcn_stack_frame::set_auto_fcn_var() : Invalid call idx=%d", static_cast<int> (avt));
+          panic ("bytecode_frame::set_auto_fcn_var() : Invalid call idx=%d", static_cast<int> (avt));
+      }
+  }
+
+  void internal_resize (std::size_t arg)
+  {
+    int diff = static_cast<int> (arg) - static_cast<int> (internal_size ());
+
+    if (diff > 0)
+      {
+        auto &lazy = lazy_data ();
+        lazy.m_extra_slots.resize (lazy.m_extra_slots.size () + diff);
+      }
+  }
+
+  void set_scope_flag_internal (std::size_t internal_offset, std::size_t external_offset, std::size_t frame_offset, scope_flags flag)
+  {
+    scope_flags current_flag = get_scope_flag_internal (internal_offset);
+
+    bool is_global = current_flag == GLOBAL;
+    bool is_pers = current_flag == PERSISTENT;
+
+
+    octave_value *ov; // Pointer to the slot
+
+    if (internal_offset >= n_compiled_syms ())
+      {
+        CHECK_PANIC (m_lazy_data);
+        ov = &m_lazy_data->m_extra_slots.at (internal_offset - n_compiled_syms ());
+      }
+    else
+      {
+        ov = &m_stack_start [internal_offset].ov;
+      }
+
+    if (flag == GLOBAL)
+      {
+        if (is_global)
+          return;
+
+        CHECK_PANIC (!is_pers); // Invalid state
+        CHECK_PANIC (frame_offset == 0);
+
+        std::string name;
+        if (internal_offset >= n_compiled_syms ())
+          name = sym_name_from_external_offset (external_offset);
+        else
+          name = m_name_data [internal_offset];
+
+        CHECK_PANIC (name != "");
+
+        if (ov->is_ref ())
+          {
+            octave_value_ref *r = ov->ref_rep ();
+            if (r->is_local_ref ())
+              r->mark_globalness_in_owning_frame (true);
+            else
+              *ov = octave_value {new octave_value_ref_global {name}};
+          }
+        else
+          *ov = octave_value {new octave_value_ref_global {name}};
+        return;
+      }
+
+    if (flag == PERSISTENT)
+      {
+        if (is_pers)
+          return;
+
+        CHECK_PANIC (!is_global);
+        CHECK_PANIC (frame_offset == 0);
+
+        *ov = octave_value {new octave_value_ref_persistent {get_scope (), static_cast<int> (external_offset)}};
+
+        return;
       }
+
+    if (flag == LOCAL)
+      {
+        if (!is_global && !is_pers)
+          return;
+
+        // Clear the global or persistent ref on the stack
+        if (is_global || is_pers)
+          {
+            // Clear the ref in its slot
+            if (ov->is_ref ())
+              {
+                octave_value_ref *r = ov->ref_rep ();
+                if (r->is_local_ref ())
+                  r->mark_globalness_in_owning_frame (false);
+                else
+                  *ov = octave_value {};
+              }
+            else
+              *ov = octave_value {};
+          }
+
+        return;
+      }
+
+    panic ("VM internal error: Strange state: %d", flag);
+  }
+
+  void set_scope_flag (std::size_t external_offset, scope_flags flag)
+  {
+    std::size_t internal_offset = external_to_local_offset (external_offset);
+
+    set_scope_flag_internal (internal_offset, external_offset, 0, flag);
+  }
+
+  stack_frame::scope_flags get_scope_flag (std::size_t external_offset) const
+  {
+    return get_scope_flag_internal (external_to_local_offset (external_offset));
+  }
+
+  stack_frame::scope_flags get_scope_flag_internal (std::size_t internal_offset) const
+  {
+    if (internal_offset >= internal_size ())
+      return LOCAL;
+
+    octave_value *pov;
+
+    // Is the slot on the original bytecode stack frame?
+    if (internal_offset < n_compiled_syms ())
+      {
+        pov = &m_stack_start [internal_offset].ov;
+      }
+    else
+      {
+        size_t extra_offset = internal_offset - n_compiled_syms ();
+        pov = &m_lazy_data->m_extra_slots.at (extra_offset);
+      }
+
+    if (!pov->is_ref ())
+      return LOCAL;
+    return pov->ref_rep ()->get_scope_flag ();
+  }
+};
+
+class bytecode_fcn_stack_frame : public bytecode_frame
+{
+public:
+
+  bytecode_fcn_stack_frame () = delete;
+
+  bytecode_fcn_stack_frame (tree_evaluator& tw,
+                            octave_user_code *fcn,
+                            std::size_t index,
+                            const std::shared_ptr<stack_frame>& parent_link,
+                            const std::shared_ptr<stack_frame>& static_link,
+                            vm &vm,
+                            int nargout, int nargin)
+    : bytecode_frame (tw, index, parent_link, static_link,
+                   nullptr, vm, fcn, nargout, nargin)
+  {
+    CHECK_PANIC (!fcn->is_user_script () && !fcn->is_nested_function());
+  }
+
+  bytecode_fcn_stack_frame&
+  operator = (const bytecode_fcn_stack_frame& elt) = delete;
+
+  bytecode_fcn_stack_frame&
+  operator = (bytecode_fcn_stack_frame&& elt) = delete;
+
+  ~bytecode_fcn_stack_frame ()
+  {
+    // vm_clear_for_cache () need to mirror the dtor
+    dispose ();
+  }
+
+  void resize (std::size_t arg)
+  {
+    int diff = static_cast<int> (arg) - static_cast<int> (size ());
+
+    if (diff > 0)
+      internal_resize (internal_size () + diff);
+  }
+
+  stack_frame::scope_flags scope_flag (const symbol_record& sym) const
+  {
+    std::size_t external_offset = sym.data_offset ();
+    std::size_t frame_offset = sym.frame_offset ();
+
+    CHECK_PANIC (frame_offset == 0);
+
+    return get_scope_flag_internal (external_to_local_offset (external_offset));
   }
 
   // We only need to override one of each of these functions.  The
@@ -775,446 +851,62 @@
   using stack_frame::varval;
   using stack_frame::varref;
 
-  octave_value varval_internal (std::size_t local_offset) const
-  {
-    size_t extra_size = (m_lazy_data ? m_lazy_data->m_extra_slots.size () : 0);
-    size_t stack_slots = m_size;
-
-    if (local_offset == 0) // Handle native int %nargout specially
-      return octave_value {m_stack_start [0].i};
-    if (local_offset < stack_slots)
-      {
-        octave_value ov = m_stack_start [local_offset].ov;
-        if (ov.is_ref ())
-          return ov.ref_rep ()->deref ();
-        return ov;
-      }
-    else
-      {
-        std::size_t extra_offset = local_offset - stack_slots;
-        if (!m_lazy_data || extra_offset >= extra_size)
-          error ("VM internal error: Trying to access extra slot out of range, %zu", extra_offset);
-        octave_value ov = m_lazy_data->m_extra_slots.at (extra_offset);
-        if (ov.is_ref ())
-          return ov.ref_rep ()->deref ();
-        return ov;
-      }
-  }
-
-  octave_value varval (std::size_t external_offset) const
-  {
-    std::size_t local_offset = external_to_local_offset (external_offset);
-    return varval_internal (local_offset);
-  }
-
   octave_value varval (const symbol_record& sym) const
   {
     std::size_t external_offset = sym.data_offset ();
     std::size_t frame_offset = sym.frame_offset ();
-    std::size_t local_offset;
-    bool allready_added;
-    bool in_this_frame = maybe_external_to_local_offset (external_offset, frame_offset, local_offset, allready_added);
-
-    bool is_script = m_fcn->is_user_script ();
-    bool is_nested = m_fcn->is_nested_function ();
-
-    if (!allready_added && (is_nested || is_script))
-      {
-        // Try to find the symbol in the root frame instead.
-        auto sym_in_root = access_link ()->lookup_symbol (sym.name ());
-        if (!sym_in_root)
-          return {}; // Not found, return nil
-        return access_link ()->varval (sym_in_root);
-      }
-    else if (!in_this_frame)
-      error ("VM internal error: Invalid call to varval() with frame offset %zu, name '%s'", frame_offset, sym.name ().c_str ());
-
-    // If the offset is out of range we return a nil ov, unless this is a script frame,
-    // in which case we need to look in enclosing frames for the symbol.
-    //
-    // Normaly any symbol will be moved to the current script frame, but a call to eval might
-    // refer to a symbol in an enclosing frame that has not been moved.
-    if (local_offset >= internal_size ())
-      {
-        if (!m_fcn->is_user_script ())
-          return {};
-        else
-          {
-            // Look in the enclosing frames for the symbol
-            auto frame = access_link ();
-            std::string name = sym.name ();
-
-            while (frame)
-            {
-              symbol_scope scope = frame->get_scope ();
-
-              symbol_record rec = scope.lookup_symbol (name);
-
-              if (rec)
-                return frame->varval (rec);
-
-              frame = frame->access_link ();
-            }
-
-            return {}; // Nothing found
-          }
-      }
-    if (local_offset >= m_size)
-      {
-        std::string nm_src = sym.name ();
-        if (!m_lazy_data)
-          panic ("bytecode_fcn_stack_frame::varval() Invalid request");
-        std::string &nm = m_lazy_data->m_extra_names.at (local_offset - m_size);
-        if (nm == "")
-          nm = nm_src;
-        else if (nm != nm_src && nm_src != "")
-          error ("VM internal error: Trying to access extra slot with the wrong name. Current: %s, New: %s\n",
-            nm.c_str (), nm_src.c_str ());
-      }
-
-    bool is_global = slot_is_global (local_offset);
-    bool is_pers = slot_is_persistent (local_offset);
-
-    if (is_global)
-      return m_evaluator.global_varval (sym.name ());
-    if (is_pers)
-      return get_scope ().persistent_varval (external_offset);
-
-    return varval_internal (local_offset);
-  }
-
-  octave_value& varref_internal (std::size_t local_offset, bool deref_refs)
-  {
-    static octave_value fake_dummy_nargout{0};
-
-    std::size_t extra_size = (m_lazy_data ? m_lazy_data->m_extra_slots.size () : 0);
-    std::size_t stack_slots = m_size;
-
-    // Handle native int %nargout specially. Note that changing
-    // the value of %nargout via the this ref wont work.
-    if (local_offset == 0)
-      return fake_dummy_nargout = octave_value {m_stack_start [0].i};
-    if (local_offset < stack_slots)
-      {
-        octave_value &ov = m_stack_start [local_offset].ov;
-        if (deref_refs && ov.is_ref ())
-          return ov.ref_rep ()->ref ();
-        return ov;
-      }
-    else
-      {
-        std::size_t extra_offset = local_offset - stack_slots;
-        if (!m_lazy_data || extra_offset >= extra_size)
-          error ("VM internal error: Trying to access extra slot out of range, %zu", extra_offset);
-        octave_value &ov = m_lazy_data->m_extra_slots.at (extra_offset);
-        if (deref_refs && ov.is_ref ())
-          return ov.ref_rep ()->ref ();
-        return ov;
-      }
-  }
-
-  octave_value& varref (std::size_t external_offset, bool deref_refs)
-  {
-    std::size_t local_offset = external_to_local_offset (external_offset);
-    return varref_internal (local_offset, deref_refs);
+
+    if (frame_offset >= n_compiled_frame_depth ())
+      return {};
+
+    std::size_t internal_offset = external_to_local_offset (external_offset, frame_offset);
+
+    // If the offset is out of range we return a nil ov. A varref() call would add
+    // an extra slot.
+    if (internal_offset >= internal_size ())
+      return {};
+
+    return varval_internal (internal_offset);
   }
 
   octave_value& varref (const symbol_record& sym, bool deref_refs)
   {
-    bool add_to_parent_scriptframes = false;
     std::size_t external_offset = sym.data_offset ();
     std::size_t frame_offset = sym.frame_offset ();
 
-    std::size_t local_offset;
-    bool allready_added;
-    bool in_this_frame = maybe_external_to_local_offset (external_offset, frame_offset, local_offset, allready_added);
-
-    bool is_nested = m_fcn->is_nested_function ();
-    bool is_script = m_fcn->is_user_script ();
-
-    if (!allready_added && (is_nested || is_script))
-      {
-        // Try to find the symbol in the root frame instead.
-        auto sym_in_root = access_link ()->insert_symbol (sym.name ());
-        CHECK_PANIC (sym_in_root.frame_offset () == 0);
-        return access_link ()->varref (sym_in_root, deref_refs);
-      }
-    else if (!in_this_frame)
-      panic ("VM internal error: Invalid call to varref() with frame offset %zu, name '%s'", frame_offset, sym.name ().c_str ());
+    CHECK_PANIC (frame_offset < n_compiled_frame_depth ());
+
+    std::size_t local_offset = external_to_local_offset (external_offset, frame_offset);
 
     // If the offset is out of range we make room for it
     if (local_offset >= internal_size ())
-    {
       internal_resize (local_offset + 1);
-      internal_set_extra_name (local_offset, sym.name ());
-
-      // If this bytecode frame is a script we need to add the symbol to the parent frames
-      if (m_fcn->is_user_script ())
-        add_to_parent_scriptframes = true;
-    }
-    if (local_offset >= m_size)
-      {
-        std::string nm_src = sym.name ();
-        if (!m_lazy_data)
-          panic ("bytecode_fcn_stack_frame::varval() Invalid request");
-        std::string &nm = m_lazy_data->m_extra_names.at (local_offset - m_size);
-        if (nm == "")
-          nm = nm_src;
-        else if (nm != nm_src && nm_src != "")
-          error ("VM internal error: Trying to access extra slot with wrong name. Current: %s, New: %s\n",
-            nm.c_str (), nm_src.c_str ());
-      }
-
-    if (add_to_parent_scriptframes)
-      {
-        // Mirrors what happens in vm_enter_script ().
-        // Essentially the octave_value in the enclosing script frame
-        // is stolen and put in this frame, and a pointer to the value in this
-        // frame is put in the enclosing frame.
-        symbol_record script_sr = sym;
-        std::string name = sym.name ();
-
-        auto eval_frame = access_link ();
-        auto eval_scope = eval_frame->get_scope ();
-        auto parent_frame = parent_link ();
-        bool caller_is_eval_frame = eval_frame == parent_frame;
-
-
-        symbol_record eval_scope_sr;
-
-        const std::map<std::string, symbol_record>& eval_scope_symbols
-          = eval_scope.symbols ();
-
-        auto p = eval_scope_symbols.find (name);
-
-        if (p == eval_scope_symbols.end ())
-          eval_scope_sr = eval_scope.insert (name);
-        else
-          eval_scope_sr = p->second;
-
-        if (eval_frame->is_global (eval_scope_sr))
-          {
-            mark_global (script_sr);
-
-            octave_value &orig = eval_frame->varref (eval_scope_sr.data_offset (), false);
-            orig = octave_value (new octave_value_ref_vmlocal {script_sr, this});
-
-            if (!caller_is_eval_frame)
-              {
-                symbol_record sr_parent = parent_frame->lookup_symbol (script_sr.name ());
-                CHECK_PANIC (sr_parent.is_valid ());
-                CHECK_PANIC (sr_parent.frame_offset () == 0);
-
-                octave_value &parent_ref = parent_frame->varref (sr_parent, false);
-
-                CHECK_PANIC (parent_frame->is_global (sr_parent));
-
-                if (&parent_ref != &orig)
-                  {
-                    CHECK_PANIC (parent_ref.is_ref () && parent_ref.ref_rep ()->is_global_ref ());
-                    parent_ref = octave_value (new octave_value_ref_vmlocal {script_sr, this});
-                  }
-              }
-          }
-        else
-          {
-            octave_value &orig_ref = eval_frame->varref (eval_scope_sr, false); // Ref to value on parent's VM stack
-            octave_value &ref = varref (script_sr, false); // Pointer to current VM stack frame
-
-            CHECK_PANIC (&ref != &orig_ref);
-
-            if (!caller_is_eval_frame)
-              {
-                symbol_record sr_parent = parent_frame->lookup_symbol (script_sr.name ());
-                CHECK_PANIC (sr_parent.is_valid ());
-
-                // If the symbol is not in the parent frame, we add it to it.
-                if (sr_parent.frame_offset ())
-                  {
-                    // Move the value from whatever parent has the it to the current stack frame
-                    ref = parent_frame->varref (sr_parent, false);
-
-                    sr_parent = parent_frame->insert_symbol (script_sr.name ()); // TODO: Need to be done to all parents missing it?
-                    octave_value &parent_ref = parent_frame->varref (sr_parent, false);
-
-                    CHECK_PANIC (&parent_ref != &orig_ref);
-                    CHECK_PANIC (&parent_ref != &ref);
-
-                    parent_ref = octave_value (new octave_value_ref_vmlocal {script_sr, this});
-                  }
-                else
-                  {
-                    octave_value &parent_ref = parent_frame->varref (sr_parent, false);
-
-                    CHECK_PANIC (&ref != &parent_ref);
-                    CHECK_PANIC (&parent_ref != &orig_ref);
-
-                    ref = parent_ref; // Move parent's value to the current stack frame
-                    parent_ref = octave_value (new octave_value_ref_vmlocal {script_sr, this});
-                  }
-              }
-            else
-              {
-                ref = orig_ref; // Move eval frame's value to current stack frame
-              }
-
-            orig_ref = octave_value (new octave_value_ref_vmlocal {script_sr, this}); // Replace parents value with reference ov.
-          }
-      }
 
     return varref_internal (local_offset, deref_refs);
   }
 
-  std::string inputname (int n, bool ids_only) const
-  {
-    std::string name;
-
-    octave_value ov_arg_names = get_auto_fcn_var (stack_frame::ARG_NAMES);
-    Array<std::string> arg_names = ov_arg_names.cellstr_value ();
-
-    if (n >= 0 && n < arg_names.numel ())
-      {
-        name = arg_names(n);
-
-        if (ids_only && ! m_static_link->is_variable (name))
-          name = "";
-      }
-
-    return name;
-  }
-
   void mark_scope (const symbol_record& sym,
                    scope_flags flag)
   {
-    bool was_global = is_global (sym);
-    bool is_script = m_lazy_data && m_lazy_data->m_is_script;
-    bool add_global_to_scripts = flag == GLOBAL && is_script;
-    bool remove_global_from_scripts = flag != GLOBAL && is_script && was_global;
-
-    bool is_nested = m_fcn->is_nested_function ();
-
     std::size_t external_offset = sym.data_offset ();
     std::size_t frame_offset = sym.frame_offset ();
 
-    std::size_t local_offset;
-    bool allready_added;
-    bool in_this_frame = maybe_external_to_local_offset (external_offset, frame_offset, local_offset, allready_added);
-
-    if (!in_this_frame || ((is_script || is_nested) && !allready_added))
-      {
-        if (!is_script && !is_nested)
-          error ("VM internal error: Invalid call to mark_scope");
-
-        auto sym_in_root = access_link ()->insert_symbol (sym.name ()); // Adds symbol if doesn't exist
-        access_link ()->mark_scope (sym_in_root, flag);
-        return;
-      }
+    CHECK_PANIC (frame_offset == 0);
+
+    std::size_t local_offset = external_to_local_offset (external_offset);
 
     if (local_offset >= internal_size ())
-      {
-        internal_resize (local_offset + 1);
-        internal_set_extra_name (local_offset, sym.name ());
-      }
-
-    set_scope_flag (external_offset, flag);
-
-    if (add_global_to_scripts)
-      {
-        symbol_record sym_access =  m_access_link->insert_symbol (sym.name ());
-        octave_value &ov_access = m_access_link->varref (sym_access.data_offset (), false);
-
-        bool make_ref = true;
-
-        if (ov_access.is_ref ())
-          {
-            octave_value_ref *r = ov_access.ref_rep ();
-            if (r->is_local_ref ())
-              make_ref = false;
-          }
-
-        m_access_link->mark_global (sym_access);
-
-        if (make_ref)
-          ov_access = octave_value (new octave_value_ref_vmlocal {sym, this});
-      }
-    else if (remove_global_from_scripts)
-      {
-        symbol_record sym_access =  m_access_link->insert_symbol (sym.name ());
-        octave_value &ov_access = m_access_link->varref (sym_access.data_offset (), false);
-
-        bool make_ref = true;
-
-        if (ov_access.is_ref ())
-          {
-            octave_value_ref *r = ov_access.ref_rep ();
-            if (r->is_local_ref ())
-              make_ref = false;
-          }
-
-        m_access_link->unmark_global (sym_access);
-
-        if (make_ref)
-          ov_access = octave_value (new octave_value_ref_vmlocal {sym, this});
-      }
+      internal_resize (local_offset + 1);
+
+    set_scope_flag_internal (local_offset, external_offset, frame_offset, flag);
   }
 
-  bool is_bytecode_fcn_frame () const { return true; }
-
-  // E.g. script_stack_frame::get_access_link() need to think the bytecode frame is a user script frame
-  // if it executes a script.
-  bool is_user_script_frame () const { return m_lazy_data ? m_lazy_data->m_is_script : false; }
-  bool is_user_fcn_frame () const { return m_lazy_data ? !m_lazy_data->m_is_script : true; }
+  bool is_user_fcn_frame () const { return true; }
 
   symbol_record lookup_symbol (const std::string& name) const
   {
-    scope_flags flag = LOCAL;
-
-    auto it = m_unwind_data->m_map_user_locals_names_to_slot.find (name);
-
-    if (it != m_unwind_data->m_map_user_locals_names_to_slot.end ())
-      {
-        int local_offset = it->second;
-
-        symbol_record ret (name, flag);
-
-        size_t frame_offset;
-        size_t offset;
-
-        local_to_external_offset (static_cast<std::size_t> (local_offset), offset, frame_offset);
-
-        ret.set_data_offset (offset);
-        ret.set_frame_offset (frame_offset);
-
-        // Check if the symbol is an argument or return symbol. Note: Negative count for vararg and varargin
-        int n_returns = static_cast<signed char> (m_code[0]);
-        if (n_returns == -128) // Magic number for anonymous function's "dynamic amount of returns"
-          n_returns = 0;
-        else
-          n_returns = abs (n_returns);
-        int n_args = abs (static_cast<signed char> (m_code[1]));
-        if (local_offset < n_returns + n_args)
-          ret.mark_formal ();
-
-        return ret;
-      }
-
-    if (m_lazy_data)
-      {
-        for (unsigned i = 0; i < m_lazy_data->m_extra_slots.size (); i++)
-          {
-            if (m_lazy_data->m_extra_names.at (i) == name)
-              {
-                symbol_record ret (name, flag);
-                ret.set_data_offset (m_orig_size + i);
-                return ret;
-              }
-          }
-      }
-
-    // Search the "scope" object of this and any nested frame
-    // The scope object will have e.g. variables added by scripts, global declares or eval
     const stack_frame *frame = this;
-    std::size_t frame_cntr = 0;
+
     while (frame)
       {
         symbol_scope scope = frame->get_scope ();
@@ -1222,17 +914,10 @@
         symbol_record sym = scope.lookup_symbol (name);
 
         if (sym)
-          {
-            // Return symbol record with adjusted frame offset relative
-            // to the one lookup is done on, i.e. the 'this' frame.
-            symbol_record new_sym = sym.dup ();
-            new_sym.set_frame_offset (new_sym.frame_offset () + frame_cntr);
-            return new_sym;
-          }
+          return sym;
 
         std::shared_ptr<stack_frame> nxt = frame->access_link ();
         frame = nxt.get ();
-        frame_cntr++;
       }
 
     return symbol_record ();
@@ -1240,23 +925,10 @@
 
   symbol_record insert_symbol (const std::string& name)
   {
-    bool is_script = m_lazy_data && m_lazy_data->m_is_script;
-
     symbol_scope scope = get_scope ();
 
     symbol_record sym = scope.lookup_symbol (name);
 
-    if (is_script)
-      {
-        // TODO: Instead of doing a call to varref to maybe insert a symbol,
-        //       common functionality between varref and insert_symbol should
-        //       be put in some function.
-        if (!sym)
-          sym = scope.find_symbol (name);
-        varref (sym, false);
-        return sym;
-      }
-
     if (!sym)
       {
         // If we have not created the extra slots, now is the time
